"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Provider = void 0;
var React = require("react");
var actionTypes_1 = require("../utils/actionTypes");
var createAction_1 = require("../createAction");
var useAccessor_1 = require("../hooks/useAccessor");
var useObservable_1 = require("../hooks/useObservable");
function Provider(_a) {
    var children = _a.children, Context = _a.Context;
    var root = React.useContext(Context);
    var _b = __read(React.useReducer(root.reducer, root.state), 2), state = _b[0], reducerDispatch = _b[1];
    var _c = __read(useAccessor_1.useAccessor(state), 1), getState = _c[0];
    var dispatch = React.useCallback(function contextDispatch(action) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                reducerDispatch(action);
                return [2 /*return*/, action];
            });
        });
    }, [reducerDispatch]);
    var unenhanced = React.useMemo(function getUnenhanced() {
        var _ = root.enhancer, value = __rest(root, ["enhancer"]);
        return Object.assign(value, { dispatch: dispatch, getState: getState });
    }, [dispatch, getState, root]);
    // Get a reference that will be set once any supplied enhancer is run.
    var _d = __read(useAccessor_1.useAccessor(), 2), getEnhanced = _d[0], setEnhanced = _d[1];
    // This is the final value to be observed.
    // The enhanced value will be given below.
    var value = React.useMemo(function getValue() {
        return __assign(__assign(__assign({}, unenhanced), getEnhanced()), { state: state });
    }, [getEnhanced, state, unenhanced]);
    // This is the observable context value that will be enhanced once.
    var _e = __read(useObservable_1.useObservable(value), 2), observable = _e[0], publish = _e[1];
    // This is called only on the initial render or if the enhancer changes.
    // It sets the enhanced value that will supplement the unenhanced value
    // on subsequent renders. It needs to be called after an observable is
    // created from the value to allow the enhancer subscribe to the value.
    React.useEffect(function enhanceAndIntialise() {
        var _a, _b;
        var enhanced = (_b = (_a = root.enhancer) === null || _a === void 0 ? void 0 : _a.call(root, observable)) !== null && _b !== void 0 ? _b : observable;
        setEnhanced(enhanced);
        enhanced.dispatch(createAction_1.createAction(actionTypes_1.ActionTypes.INIT)());
    }, 
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [root.enhancer]);
    // Notify only on a change to the observed value. This is scheduled after
    // the enhance effect to ensure the first render notifies all subscribers.
    // eslint-disable-next-line react-hooks/exhaustive-deps
    React.useEffect(publish, [observable]);
    return React.createElement(Context.Provider, { value: observable }, children);
}
exports.Provider = Provider;
