"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createDuck = void 0;
var createReducer_1 = require("./createReducer");
var createAction_1 = require("./createAction");
var getEntries_1 = require("./utils/getEntries");
function getNS(name, actionType) {
    return name + "/" + actionType;
}
function createDuck(_a) {
    var e_1, _b;
    var name = _a.name, initialState = _a.initialState, reducers = _a.reducers, selectors = _a.selectors, actionMapping = _a.actionMapping;
    var mappedActionTypes = __assign({}, actionMapping);
    var actions = {};
    try {
        for (var _c = __values(getEntries_1.getEntries(reducers)), _d = _c.next(); !_d.done; _d = _c.next()) {
            var _e = __read(_d.value, 1), actionType = _e[0];
            var namespacedActionType = getNS(name, actionType);
            actions[actionType] = createAction_1.createAction(namespacedActionType);
            mappedActionTypes[namespacedActionType] = actionType;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_d && !_d.done && (_b = _c.return)) _b.call(_c);
        }
        finally { if (e_1) throw e_1.error; }
    }
    var actionReducer = createReducer_1.createReducer(initialState, reducers);
    var isMappedActionType = function (a) {
        return a !== undefined &&
            Object.prototype.hasOwnProperty.call(mappedActionTypes, a.type);
    };
    function reducer(state, action) {
        return actionReducer(state, __assign(__assign({}, action), { type: isMappedActionType(action)
                ? mappedActionTypes[action.type]
                : action.type }));
    }
    return {
        actions: actions,
        initialState: initialState,
        name: name,
        reducer: reducer,
        selectors: selectors,
    };
}
exports.createDuck = createDuck;
