"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createReducer = void 0;
function createReducer(initialState, actionTypeToReducer, defaultReducer) {
    var isReducerActionType = function (a) {
        return a !== undefined &&
            Object.prototype.hasOwnProperty.call(actionTypeToReducer, a.type);
    };
    return function actionReducer(state, action) {
        var _a;
        if (state === void 0) { state = initialState; }
        if (!isReducerActionType(action)) {
            return (_a = defaultReducer === null || defaultReducer === void 0 ? void 0 : defaultReducer(state, action)) !== null && _a !== void 0 ? _a : state;
        }
        return actionTypeToReducer[action.type](state, action);
    };
}
exports.createReducer = createReducer;
