"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRootDuck = void 0;
var combineReducers_1 = require("./utils/combineReducers");
var combineSelectors_1 = require("./utils/combineSelectors");
function createRootDuck() {
    var e_1, _a;
    var ducks = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        ducks[_i] = arguments[_i];
    }
    var rootDuck = {
        actions: {},
        initialState: {},
        names: new Set(ducks.map(function (d) { return d.name; })),
        selectors: {},
    };
    var reducerMapping = {};
    try {
        for (var ducks_1 = __values(ducks), ducks_1_1 = ducks_1.next(); !ducks_1_1.done; ducks_1_1 = ducks_1.next()) {
            var duck = ducks_1_1.value;
            var duckName = duck.name;
            rootDuck.actions[duckName] = duck.actions;
            rootDuck.initialState[duckName] = duck.initialState;
            rootDuck.selectors[duckName] = combineSelectors_1.combineSelectors(duckName, duck.selectors);
            reducerMapping[duckName] = duck.reducer;
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (ducks_1_1 && !ducks_1_1.done && (_a = ducks_1.return)) _a.call(ducks_1);
        }
        finally { if (e_1) throw e_1.error; }
    }
    rootDuck.reducer = combineReducers_1.combineReducers(rootDuck.initialState, reducerMapping);
    return rootDuck;
}
exports.createRootDuck = createRootDuck;
