"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useAccessor = void 0;
var React = require("react");
function useAccessor(value) {
    var ref = React.useRef(value);
    // eslint-disable-next-line react-hooks/exhaustive-deps
    var initialized = React.useMemo(function () { return value !== undefined; }, []);
    var getValue = React.useCallback(function getValue() {
        return ref.current;
    }, []);
    var setValue = React.useCallback(function setValue(value) {
        ref.current = value;
    }, []);
    // If a value was initially provided then keep the ref updated
    if (initialized)
        setValue(value);
    // If a value was initially provided then no setter is returned
    return [getValue, initialized ? undefined : setValue];
}
exports.useAccessor = useAccessor;
