"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDispatch = void 0;
var React = require("react");
var bindActionCreators_1 = require("../utils/bindActionCreators");
var __1 = require("..");
function useDispatch(actionCreator, Context) {
    var dispatch = React.useContext(Context !== null && Context !== void 0 ? Context : __1.GlobalContext).dispatch;
    var boundActionCreator = React.useMemo(function () { return bindActionCreators_1.bindActionCreator(actionCreator, dispatch); }, [actionCreator, dispatch]);
    if (!boundActionCreator) {
        throw new Error("Unable to bind action creator \"" + actionCreator + "\" to disptch");
    }
    return React.useCallback(boundActionCreator, [boundActionCreator]);
}
exports.useDispatch = useDispatch;
