"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.applyMiddleware = void 0;
// github.com/reduxjs/redux/blob/8551ba8/src/applyMiddleware.ts
var compose_1 = require("./compose");
function applyMiddleware() {
    var middlewares = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        middlewares[_i] = arguments[_i];
    }
    return function enhancer(context) {
        function dispatchStub() {
            throw new Error("Dispatching while constructing your middleware is not allowed. " +
                "Other middleware would not be applied to this dispatch.");
        }
        var middlewareAPI = {
            dispatch: dispatchStub,
            getState: context.getState,
        };
        var chain = middlewares.map(function (middleware) {
            return middleware(middlewareAPI);
        });
        var dispatch = compose_1.compose.apply(void 0, __spread(chain))(context.dispatch);
        return __assign(__assign({}, context), { dispatch: dispatch });
    };
}
exports.applyMiddleware = applyMiddleware;
