export declare function bindActionCreator<T extends string, P>(actionCreator: Nullable<ActionCreator<T, P>>, dispatch: ContextDispatch<T, P>): Nullable<ActionDispatcher<P>>;
/**
 * Turns an object whose values are action creators, into an object with the
 * same keys, but with every function wrapped into a `dispatch` call so they
 * may be invoked directly.
 */
export declare function bindActionCreators<T extends string, P>(actionCreator: Nullable<ActionCreator<T, P>>, dispatch: ContextDispatch<T, P>): ActionDispatcher<P>;
export declare function bindActionCreators<T extends string, P, S>(actionCreators: Nullable<ActionCreatorMapping<T, P, S>>, dispatch: ContextDispatch<T, P>): ActionDispatcherMapping<T, P>;
