"use strict";
// github.com/reduxjs/redux/blob/208d7f1/src/bindActionCreators.ts
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.bindActionCreators = exports.bindActionCreator = void 0;
function bindActionCreator(actionCreator, dispatch) {
    if (typeof actionCreator !== "function")
        return;
    return function dispatchAction() {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        dispatch(actionCreator.apply(void 0, __spread(args)));
    };
}
exports.bindActionCreator = bindActionCreator;
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
function bindActionCreators(actionCreators, dispatch) {
    if (typeof actionCreators === "function") {
        return bindActionCreator(actionCreators, dispatch);
    }
    if (typeof actionCreators !== "object" || actionCreators === null) {
        throw new Error("bindActionCreators expected an object or a function, instead received " + (actionCreators === null ? "null" : typeof actionCreators) + ". " +
            'Did you write "import ActionCreators from" instead of "import * as ActionCreators from"?');
    }
    var boundActionCreators = {};
    for (var key in actionCreators) {
        var bound = bindActionCreator(actionCreators[key], dispatch);
        if (bound) {
            boundActionCreators[key] = bound;
        }
    }
    return boundActionCreators;
}
exports.bindActionCreators = bindActionCreators;
