"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.connect = void 0;
var React = require("react");
var Context_1 = require("../components/Context");
var bindActionCreators_1 = require("./bindActionCreators");
var isFunction_1 = require("./isFunction");
function defaultMergeProps(stateProps, dispatchProps, ownProps) {
    return __assign(__assign(__assign({}, ownProps), stateProps), dispatchProps);
}
function asMapDispatchToPropsFn(actionCreators) {
    return (actionCreators &&
        function mapDispatchToProps(dispatch) {
            return bindActionCreators_1.bindActionCreators(actionCreators, dispatch);
        });
}
function connect(mapStateToProps, mapDispatchToProps, mergeProps, options) {
    var mapDispatchToPropsFn = isFunction_1.isFunction(mapDispatchToProps)
        ? mapDispatchToProps
        : asMapDispatchToPropsFn(mapDispatchToProps);
    return function wrap(WrappedComponent) {
        var FinalComponent = ((options === null || options === void 0 ? void 0 : options.pure) ? React.memo(WrappedComponent)
            : WrappedComponent);
        var wrappedComponentName = WrappedComponent.displayName ||
            WrappedComponent.name ||
            "Component";
        var displayName = "Connect(" + wrappedComponentName + ")";
        function WrapperFunction(props, ref) {
            var _a;
            var _b = React.useContext((_a = options === null || options === void 0 ? void 0 : options.context) !== null && _a !== void 0 ? _a : Context_1.GlobalContext), state = _b.state, dispatch = _b.dispatch;
            var stateProps = React.useMemo(function () { return mapStateToProps === null || mapStateToProps === void 0 ? void 0 : mapStateToProps(state, props); }, [props, state]);
            var dispatchProps = React.useMemo(function () { return mapDispatchToPropsFn === null || mapDispatchToPropsFn === void 0 ? void 0 : mapDispatchToPropsFn(dispatch, props); }, [dispatch, props]);
            var mergedProps = React.useMemo(function () {
                return (mergeProps !== null && mergeProps !== void 0 ? mergeProps : defaultMergeProps)(stateProps, dispatchProps, props);
            }, [dispatchProps, props, stateProps]);
            var finalProps = React.useMemo(function () {
                return (options === null || options === void 0 ? void 0 : options.forwardRef) ? __assign(__assign({}, mergedProps), { ref: ref }) : mergedProps;
            }, [mergedProps, ref]);
            return React.createElement(FinalComponent, __assign({}, finalProps));
        }
        WrapperFunction.displayName = displayName;
        var WrapperComponent = (options === null || options === void 0 ? void 0 : options.forwardRef) ? React.forwardRef(WrapperFunction)
            : WrapperFunction;
        Object.assign(WrapperComponent, { WrappedComponent: WrappedComponent });
        return WrapperComponent;
    };
}
exports.connect = connect;
